﻿using System;
using System.Linq;
using Diagrams.PascalTriangle.ViewModels;
using Telerik.Windows.Controls;

namespace Diagrams.PascalTriangle.View
{
	public class CustomDiagram : RadDiagram
	{
		protected override bool IsItemItsOwnShapeContainerOverride(object item)
		{
			return item is BaseView || item is Shape1View || item is Shape2View;
		}

		protected override Telerik.Windows.Diagrams.Core.IShape GetShapeContainerForItemOverride(object item)
		{
			if (item is BaseViewModel)
			{
				return new BaseView();
			}
			else if (item is Shape1ViewModel)
			{
				return new Shape1View();
			}
			else 
			{
				return new Shape2View();
			}
		}
	}
}
