﻿using System.IO;
using System.Windows;
using Diagrams.PascalTriangle.ViewModels;
using Microsoft.Win32;
using Telerik.Windows.Controls;
using Telerik.Windows.DragDrop;

namespace Diagrams.PascalTriangle.View
{
	public partial class MainView
	{
		private const int RootXPosition = 400;
		private const int RootYPosition = 20;
		private const int XDelimiterWidth = 80;
		private const int YDelimiterHeight = 60;
		private const int XStartNegativeOffset = 40;

		public MainView()
		{
			this.InitializeComponent();
			this.DataContext = new ListBoxDataContext();
			CustomGraphSource grapshSource = new CustomGraphSource();
			grapshSource.InternalItems.Add(new BaseViewModel() { Position = new Point(100, 100) });
			grapshSource.InternalItems.Add(new Shape1ViewModel() { Position = new Point(200, 100) });
			grapshSource.InternalItems.Add(new Shape2ViewModel() { Position = new Point(300, 100) });

			this.xDiagram.GraphSource = grapshSource;
		}
		private string fileName;
		private void saveButton_Click(object sender, RoutedEventArgs e)
		{
			Stream fileStream = null;
			try
			{
				var dialog = new SaveFileDialog();
				if (dialog.ShowDialog() == true)
				{
					fileStream = dialog.OpenFile();
					this.fileName = dialog.FileName;
				}

				using (fileStream)
				{
					var serializationString = this.xDiagram.Save();
					var writer = new StreamWriter(fileStream);
					writer.Write(serializationString);
					writer.Flush();
				}
			}
			finally
			{
				if (fileStream != null)
					fileStream.Close();
			}

		}

		private void loadButton_Click(object sender, RoutedEventArgs e)
		{
			Stream fileStream = null;
			try
			{
				var dialog = new OpenFileDialog();
				dialog.ShowDialog();
				using (fileStream = dialog.OpenFile())
				{
					StreamReader reader = new StreamReader(fileStream);
					using (reader)
					{
						string serializedString = reader.ReadToEnd();
						this.xDiagram.Load(serializedString);
					}
				}
			}
			finally
			{
				if (fileStream != null)
					fileStream.Close();
			}
		}

		private void xDiagram_Serialized_1(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{

		}

		private void xDiagram_ShapeSerialized_1(object sender, Telerik.Windows.Controls.Diagrams.ShapeSerializationRoutedEventArgs e)
		{

		}


	}
}