﻿using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;
using Telerik.Windows.Diagrams.Core;

namespace Diagrams.PascalTriangle.ViewModels
{
    public class CustomGraphSource : IGraphSource
    {
		public CustomGraphSource()
        {
            this.InternalItems = new ObservableCollection<NodeViewModelBase>();
            this.InternalEdges = new ObservableCollection<LinkViewModelBase<NodeViewModelBase>>();
        }

		public ObservableCollection<NodeViewModelBase> InternalItems
        {
            get;
            private set;
        }

		public ObservableCollection<LinkViewModelBase<NodeViewModelBase>> InternalEdges
        {
            get;
            private set;
        }

        IEnumerable<ILink> IGraphSource.Links
        {
            get { return this.InternalEdges; }
        }

        IEnumerable IGraphSource.Items
        {
            get { return this.InternalItems; }
        }
    }
}
